
      options /extend_source
      program daleks
      !
      ! (C) Jon Prestidge 1996
      !
      implicit none
      character text*80, users_name*20, new_line*2
      integer*4 status, str_to_int4, I, pos, pos2, rec_len, speed_up,
     .          temp_int, key_code, pos3, dalek_avail, pos4, dalek_selected,
     .          any_dalek_available
      include 'daleks_inc'
      !
      !
      !
      ! INITIALIZE DATA...
      do I = 1, max_daleks
         d_mbx_dev( I ) = '-'
      end do       
      new_line = char( 13 ) // char( 10 )
      kb_ch = 0
      next_col = -1
      next_lin = -1
      !
      call daleks_screen_ini
      call daleks_CLS
      !
      !
      dalek_selected = 0
      any_dalek_available = 0
      !
      ! Check that the server is running...
      !
      !
      open ( unit=1, file='DALEKS_DIR:DALEKS_SERVER_LOCK.DAT',
     .       organization='sequential', carriagecontrol='none',
     .       IOstat=status, status='old', shared )
      !
      if ( status .EQ. 29 .or. status .EQ. 0 ) then
         print *, 'The Daleks server is not running.'
         print *, 'Please contact your system manager or your games master'
         print *, 'and ask them to start the Daleks server.'
         if ( status .EQ. 0 ) close( unit=1 )
         call lib$wait( 2.0 )
         goto 99
      else if ( status .NE. 30 ) then
         print *, 'UNEXPECTED ERROR accessing DALEKS_DIR:DALEKS_SERVER_LOCK.DAT'
         print *, 'FORTRAN error #', status
         goto 99
      end if
      !
      !
      !
      open ( unit=1, FILE='DALEKS_DIR:DALEKS.DAT', status='OLD',
     .       carriagecontrol='list', IOstat=status )
      !
      if ( status .EQ. 30 ) then
         ! N.B... not to system managers: if this message is displayed
         ! when no-one is entering the game then it might be because
         ! the DALEKS.DAT file has not got the protection W:RW and
         ! a low priv user is playing.
         ! 
         print *, 'Someone else is entering the game right now.'
         print *, 'Try again in a few seconds'
         call lib$wait( 2.0 )
         goto 99
      else if ( status .NE. 0 ) then
         print '(a,I3)', ' Could not open daleks file (DALEKS_DIR:DALEKS.DAT)'
         print *, 'Is the DALEKS_DIR: logical valid.  Does it point to a readable and writable directory?'
         print *, 'FORTRAN error #', status
         call lib$wait( 2.0 )
         goto 99
      end if
      !
      !
      !
      !
      !
      print *,  '>>>>MULTI-USER DALEKS<<<<'

      print *,  'Once, Daleks were trying to take-over the whole universe but after many defeats'
      print *,  'by various time-lords they thought "What the hell ... let''s just pick a nice'
      print *,  'sunny plannet chill-out from the whole invasion thing".  Instead of blasting'
      print *,  'time-lords they now have to content themselves with taking pot-shots at each'
      print *,  'other for entertainment.'
      print *,  'Daleks is a muli-user game for upto 10 players logged-into the same VMS node.'
      print *,  ' '
      !
      !
      !
      !
      !
      !
      !
      !
      do while ( status .EQ. 0 )
         !
         read ( unit=1, fmt='(a)', IOstat=status ) text
         !
         if ( status .eq. -1 ) goto 39  ! EOF so exit loop
         !
         if ( status .NE. 0 ) then
            print '(a,I3)', 'Could not read daleks file (DALEKS.DAT) Error #',
     .            status
            goto 99
         end if
         !
         pos = index( text, '=' )
         if ( pos .LE. 2 ) goto 39 ! ignore line
         !
         dalek_avail = INVALID_AVAIL
         !
         pos2 = index( text, '#' )
         if ( pos2 .NE. 0 ) dalek_avail = free
         !
         if ( pos2 .EQ. 0 ) then
            pos2 = index( text, '/' )
            if ( pos2 .NE. 0 ) dalek_avail = TAKEN
         end if
         !
         if ( pos2 .EQ. 0 ) then
            pos2 = index( text, '\' )
            if ( pos2 .NE. 0 ) dalek_avail = RIP
         end if
         !
         if ( pos2 .EQ. 0 ) goto 39 ! ignore line
         !
         pos4 = index( text, ',' )
         if ( pos4 .EQ. 0 ) goto 39 ! ignore line
         !
         n = str_to_int4( text(pos2+1:pos2+2) )
         if ( n .LT. 1 .or. n .GT. max_daleks ) goto 39  ! ignore bad dalek num.
         !
         pos3 = index( text, '|' )
         !
         if ( pos3 .LE. pos2 .or. pos3 .EQ. 0 ) goto 39 ! ignore line
         !
         d_mbx_dev( n ) = text(pos+1:pos3-1)
         !
         if ( dalek_avail .NE. FREE .or. index( d_mbx_dev( n ), ':' ).EQ.0) then
            ! make invalid for selection since the dalek is taken or dead
            ! or the mail box dev name is missing
            d_mbx_dev( n ) = '-'
         end if
         !
         inquire( file=d_mbx_dev( n ), IOstat=status )
         !
         if ( status .NE. 0 ) d_mbx_dev( n ) = '-'
         !
         if ( dalek_avail .EQ. FREE ) then
            print '(1X,I2,A)', n,
     .                         ') ' //
     .                         text(:pos4-1) //
     .                         ' Ready to go.'
            any_dalek_available = -1
         else if ( dalek_avail .EQ. TAKEN ) then
            print *, '--) ' // text(:pos4-1) // ' alias ' // text(pos3+1:)
         else if ( dalek_avail .EQ. RIP ) then
            print *, '--) ' // text(:pos4-1) //
     .          ' EXTERMINATED!'
         end if
         !
         !
39    end do
      !
      if ( any_dalek_available .EQ. 0 ) then
         !
         print *, 'There are no daleks available.'
         print *, 'When all daleks are exterminated and all players have'
         print *, 'exited the server will start a new game'
         call lib$wait( 3.0 )
         goto 99
         !
      end if
      !
      status = -1
      do while ( status .NE. 0 )
        !
        print *, ' '
        print '(a)', '$Enter the number of the dalek you want to play (or ^Z to exit): '
        read ( unit=*, fmt='(I2)', end=99, IOstat=status ) n
        !
        if ( status .Ne. 0 ) then
           print *, 'INPUT ERROR'
        else if ( n .LT. 1 .or. n .GT. max_daleks ) then
           print *, 'Invalid dalek number'
           status = -1
        else if ( d_mbx_dev( n ) .EQ. '-' ) then
           print *, 'That dalek is dead or is being currently played.'
           status = -1
        else ! try and open comms with the mail box...
           open ( unit=2, file=d_mbx_dev( n ), IOstat=status,
     .          carriagecontrol='list', status='old', form='formatted' ) 
           if ( status .Ne. 0 ) then
              print *, 'Sorry - I cannot open comms with the daleks_server!'
              print *, 'If you are running this on a VMScluster then make'
              print *, 'sure you''re logged into the node that is running the server'
              print *, 'FORTRAN error #', status
              call lib$wait( 3.0 )
              goto 99
           end if               
           !   
        end if
        !
      end do
      !
      call daleks_profile( 3, n )
      dalek_selected = -1
      !
      call daleks_cls
      print *, ' '
      print *, '                         ------------------------------'
      print *, '                             YOUR DALEK''S PROFILE:-'
      print *, '                         Death-ray range  :', max_DR_distance
      print *, '                         Max forward speed:', max_forward_speed
      print *, '                         Max reverse speed:', max_reverse_speed
      print *, '                         ------------------------------'
      print *, ' '
      print *, '       Keys:-                              Objects:-  '
      print *, '             UP - Speed-up                    @ - Health sapper'
      print *, '           DOWN - Slow-down                   # - Health restoration pad'
      print *, '           LEFT - Turn left                 (9) - Telepad'
      print *, '          RIGHT - Turn right              ***** - Death Ray'
      print *, '      Space bar - Full speed ahead'
      print *, '         RETURN - Fire Death Ray'
      print *, '      Control-Z - Exit'
      print *, ' '
      !
      !
      status = -1
      do while ( status .NE. 0 )
         !
         print *, ' '
         print '(a)', '$Enter your name (or control-Z to exit): '
         users_name = ' '
         read ( unit=*, fmt='(a)', end=99, IOstat=status ) users_name
         !
         if ( status .Ne. 0 ) then
            print *, 'INPUT ERROR'
         else if ( users_name(1:1) .EQ. ' ' ) then
            status = 1
            print *,
     .        'You must enter your name ( just your first name''ll do buddy! )'
         else
            status = 0
         end if
         !
      end do
      !
      status = -1
      do while ( status .NE. 0 )
         !
         print *, ' '
         print *, 'If you are using a terminal emulator rather than a real VT100, VT220, VT...'
         print *, 'then double width mode may not work properly.'
         print '(a)', '$Use double width mode (Y or N) [Y] ? '
         read ( unit=*, fmt='(a)', end=99, IOstat=status ) text
         !
         if ( status .Ne. 0 ) then
            print *, 'INPUT ERROR'
         else if ( text .EQ. 'y' .or. text .EQ. 'Y' .or.
     .             text .EQ. ' ' .or. text .EQ. char( 0 ) ) then
            width_mode = -1
         else if ( text .EQ. 'n' .or. text .EQ. 'N' ) then
            width_mode = 0
         else
            print *, 'INVALID REPLY'
            status = -1
         end if
         !
      end do
      !
      ! Update the daleks file with the selected daleks flaged as taken...
      !
      rewind ( unit=1 )
      !
      status = 0
      do while ( status .EQ. 0 )
         !
         read ( unit=1, fmt='(q,a)', IOstat=status ), rec_len, text
         !
         if ( status .EQ. 0 ) then
            pos2 = index( text, '#' )
            !
            if ( pos2 .GT. 0 ) then
               temp_int = str_to_int4( text(pos2+1:pos2+2) )
               !
               if ( temp_int .EQ. n ) then
                  text(pos2:pos2) = '/'   ! cancel dalek from daleks.dat
                  pos3 = index( text, '|' )
                  if ( pos3 .GT. 0 ) text(pos3+1:) = users_name
                  rewrite ( unit=1, fmt='(a)' ) text(1:rec_len)
               end if
               !
            end if
            !
         end if
         !
      end do
      !
      !
      close ( unit=1 ) ! release the dalek data file for other users
      !
      !
      call daleks_read_world( 10 )
      !
      !call Z_ini( 'M', 'SYS$HELP:', 50 )
      !
      !
      call daleks_CLS
      !
      wld_offs_lin = 0
      wld_offs_col = 0 
      od( n ).DR_distance = -1
      od( n ).ang = 0
      do I = 1, 5
        od( n ).DR_lin( I ) = 0
        od( n ).DR_col( I ) = 0
      end do
      od( n ).col = 1
      od( n ).lin = 1
      od( n ).col = 1
      od( n ).glin = 1
      od( n ).gcol = 1
      od( n ).ang = 1
      od( n ).speed = 0
      od( n ).status = 0
      !
      call daleks_cancel_DR( n )
      d( n ).move_count = 0
      d( n ).speed = 0
      d( n ).status = 1
      d( n ).health = max_health
      !
      call daleks_backdrop
      !
      status = 1
      speed_up = 0
      do while ( d( n ).status .NE. 0 )
         !
         call daleks_inkey( key_code )
         !
         if ( key_code .EQ. right_key ) then
            d( n ).ang = d( n ).ang + 1
            if ( d( n ).ang .GT. 8 ) d( n ).ang = 1
         end if
         !
         if ( key_code .EQ. left_key ) then
            d( n ).ang = d( n ).ang - 1
            if ( d( n ).ang .LT. 1 ) d( n ).ang = 8
         end if
         !
         if ( key_code .EQ. up_key ) then
            d( n ).speed = d( n ).speed + 1
            if ( d( n ).speed .GT. max_forward_speed )
     .                  d( n ).speed = max_forward_speed
         end if
         !
         if ( key_code .EQ. down_key ) then
            d( n ).speed = d( n ).speed - 1
            if ( d( n ).speed .LT. -max_reverse_speed )
     .            d( n ).speed = -max_reverse_speed
         end if
         !
         if ( key_code .EQ. return_key ) then  !fire death ray unless already active
            if ( d( n ).DR_distance .LT. 0 )  
     .         d( n ).DR_distance = 0 !initiate death-ray sequence 
         end if
         !
         if ( key_code .EQ. 32 ) then  ! full speed ahead
            speed_up = -1
         end if
         !
         if ( speed_up .Ne. 0 ) then
            d( n ).speed = d( n ).speed + 1
            if ( d( n ).speed .GT. max_forward_speed ) then
               d( n ).speed = max_forward_speed
               speed_up = 0
            end if
         end if
         !
         if ( key_code .EQ. EXIT_key ) d( n ).status = 9  !Die
         !
         call DALEKS_move
         !
         write ( unit=2,fmt='(I1,4I3,I1,I2,I1,I2,I1,10I3,I1)' ) 
     .            d( n ).status,    !I1
     .            d( n ).lin,       !I3
     .            d( n ).col,       !I3
     .            d( n ).glin,      !I3
     .            d( n ).gcol,      !I3
     .            d( n ).ang,       !I1
     .            d( n ).speed,     !I2
     .            d( n ).move_count, !I1
     .            d( n ).DR_distance, !I2
     .            d( n ).DR_ang,      !I1
     .            d( n ).DR_lin( 1 ), !I3
     .            d( n ).DR_col( 1 ),
     .            d( n ).DR_lin( 2 ),
     .            d( n ).DR_col( 2 ),
     .            d( n ).DR_lin( 3 ),
     .            d( n ).DR_col( 3 ),
     .            d( n ).DR_lin( 4 ),
     .            d( n ).DR_col( 4 ),
     .            d( n ).DR_lin( 5 ),
     .            d( n ).DR_col( 5 ),
     .            d( n ).health
         !
         read ( unit=2,fmt='(10(I1,4I3,I1,I2,I1,I2,I1,10I3,I1))' )
     .          ( d( I ).status,
     .            d( I ).lin,
     .            d( I ).col,
     .            d( I ).glin,
     .            d( I ).gcol,
     .            d( I ).ang,
     .            d( I ).speed,
     .            d( I ).move_count,
     .            d( I ).DR_distance,
     .            d( I ).DR_ang,
     .            d( I ).DR_lin( 1 ),
     .            d( I ).DR_col( 1 ),
     .            d( I ).DR_lin( 2 ),
     .            d( I ).DR_col( 2 ),
     .            d( I ).DR_lin( 3 ),
     .            d( I ).DR_col( 3 ),
     .            d( I ).DR_lin( 4 ),
     .            d( I ).DR_col( 4 ),
     .            d( I ).DR_lin( 5 ),
     .            d( I ).DR_col( 5 ),
     .            d( I ).health, I=1,10)
         !
         call daleks_draw
         !
         do I = 1, max_daleks
            od( I ) = d( I )
         end do
         !
         if ( d( n ).status .EQ. 0 ) then
            call lib$wait( 0.1 )
            call daleks_print( d( n ).lin-1, d( n ).col-5, '[[EXTERMINATED!]]' )
            call lib$wait( 2.0 )
         end if
         !
      end do
      !
      !call smg$delete_pasteboard( pasteboard_ID )
      close ( unit=1 )
      !
99    call daleks_CLS
      call daleks_screen_term
      if ( kb_ch .NE. 0 ) call sys$dassgn( %val( kb_ch ) )
      if ( dalek_selected .NE. 0 ) call daleks_exterminate_from_file
      print *, 'GAME OVER'
      !
      end


      options/extend_source
      subroutine daleks_exterminate_from_file
      !
      implicit none
      integer*4 status, pos2, temp_int, str_to_int4, rec_len
      character text*80
      include 'daleks_inc.for'
      !
10    open ( unit=1, FILE='DALEKS_DIR:DALEKS.DAT', status='OLD',
     .       carriagecontrol='list', IOstat=status )
      !
      !
      if ( status .EQ. 30 ) then
         print *, 'Waiting to access the daleks database...'
         call lib$wait( 2.0 )
         goto 10
      else if ( status .NE. 0 ) then
         print '(a,I3)', ' Could not open daleks file for an EXTERMINATION (DALEKS_DIR:DALEKS.DAT)'
         print *, 'Is the DALEKS_DIR: logical valid.  Does it point to a readable and writable directory?'
         print *, 'FORTRAN error #', status
         call lib$wait( 2.0 )
         RETURN
      end if
      !
      status = 0
      do while ( status .EQ. 0 )
         !
         read ( unit=1, fmt='(q,a)', IOstat=status ), rec_len, text
         !
         if ( status .EQ. 0 ) then
            pos2 = index( text, '/' )
            !
            if ( pos2 .GT. 0 ) then
               temp_int = str_to_int4( text(pos2+1:pos2+2) )
               !
               if ( temp_int .EQ. n ) then
                  text(pos2:pos2) = '\'   ! flag that dalek is exterminated
                  rewrite ( unit=1, fmt='(a)' ) text(1:rec_len)
               end if
               !
            end if
            !
         end if
         !
      end do
      ! 
      close( unit=1 )
      !
      end

      options/extend_source
      subroutine daleks_cancel_DR( num )
      !
      implicit none
      integer*4 num, I
      include 'daleks_inc.for'
      !
      d( num ).DR_distance = -1
      d( num ).DR_ang = 0
      !
      do I = 1, 5
        d( num ).DR_lin( I ) = 0
        d( num ).DR_col( I ) = 0
      end do
      !
      end



      options/extend_source
      subroutine daleks_CLS
      !
      implicit none
      !
      write ( unit=99 ) char( 27 ) // 'H' // char( 27 ) // 'J' 
      !
      end





      options/extend_source
      subroutine DALEKS_move
      !
      implicit none
      include 'daleks_inc.for'
      integer*4  lin, col, ang, temp_lin, temp_col, I, OK_count, error_count
      !
      if ( d( n ).status .LE. 9 .and.
     .     d( n ).status .GE. 5       ) then
         ! Dalek explosion sequnce
         !
         d( n ).status = d( n ).status - 1
         !
         if ( d( n ).status .LT. 5 ) then
            !
            d( n ).status = 0
            d( n ).move_count = 0
            d( n ).speed = 0
            call daleks_cancel_DR( n )
            return
            !
         end if
         !
         d( n ).ang = d( n ).ang + 1
         if ( d( n ).ang .GT. 8 ) d( n ).ang = 1
         d( n ).gcol = d( n ).gcol + 1
         d( n ).glin = d( n ).glin + 1
         return
         !
      end if 
      !
      d( n ).move_count = d( n ).move_count + 1
      if ( d( n ).speed .EQ. 0 ) d( n ).move_count = 0
      !
      if ( d( n ).move_count .GE. 10 - abs( d( n ).speed ) ) then
         d( n ).move_count = 0
         if ( d( n ).speed .GE. 0 ) then
            !
            if ( d( n ).ang .EQ. 1 ) then
               d( n ).lin = d( n ).lin - 1
            else if ( d( n ).ang .EQ. 2 ) then
               d( n ).lin = d( n ).lin - 1
               d( n ).col = d( n ).col + 1
            else if ( d( n ).ang .EQ. 3 ) then
               d( n ).col = d( n ).col + 1
            else if ( d( n ).ang .EQ. 4 ) then
               d( n ).lin = d( n ).lin + 1
               d( n ).col = d( n ).col + 1
            else if ( d( n ).ang .EQ. 5 ) then
               d( n ).lin = d( n ).lin + 1
            else if ( d( n ).ang .EQ. 6 ) then
               d( n ).lin = d( n ).lin + 1
               d( n ).col = d( n ).col - 1
            else if ( d( n ).ang .EQ. 7 ) then
               d( n ).col = d( n ).col - 1
            else if ( d( n ).ang .EQ. 8 ) then
               d( n ).lin = d( n ).lin - 1
               d( n ).col = d( n ).col - 1
            end if
            !
         else ! Dalek is reversing...
            !
            if ( d( n ).ang .EQ. 1 ) then
               d( n ).lin = d( n ).lin + 1
            else if ( d( n ).ang .EQ. 2 ) then
               d( n ).lin = d( n ).lin + 1
               d( n ).col = d( n ).col - 1
            else if ( d( n ).ang .EQ. 3 ) then
               d( n ).col = d( n ).col - 1
            else if ( d( n ).ang .EQ. 4 ) then
               d( n ).lin = d( n ).lin - 1
               d( n ).col = d( n ).col - 1
            else if ( d( n ).ang .EQ. 5 ) then
               d( n ).lin = d( n ).lin - 1
            else if ( d( n ).ang .EQ. 6 ) then
               d( n ).lin = d( n ).lin - 1
               d( n ).col = d( n ).col + 1
            else if ( d( n ).ang .EQ. 7 ) then
               d( n ).col = d( n ).col + 1
            else if ( d( n ).ang .EQ. 8 ) then
               d( n ).lin = d( n ).lin + 1
               d( n ).col = d( n ).col + 1
            end if
            !
         end if
         !
      end if
      !
      if ( d( n ).ang .EQ. 1 ) then       !  |
         d( n ).glin = d( n ).lin - 1
         d( n ).gcol = d( n ).col
      else if ( d( n ).ang .EQ. 2 ) then  !   /
         d( n ).glin = d( n ).lin - 1
         d( n ).gcol = d( n ).col + 1
      else if ( d( n ).ang .EQ. 3 ) then  !   -
         d( n ).glin = d( n ).lin
         d( n ).gcol = d( n ).col + 1
      else if ( d( n ).ang .EQ. 4 ) then  !   \
         d( n ).glin = d( n ).lin + 1
         d( n ).gcol = d( n ).col + 1
      else if ( d( n ).ang .EQ. 5 ) then  !  |
         d( n ).glin = d( n ).lin + 1
         d( n ).gcol = d( n ).col
      else if ( d( n ).ang .EQ. 6 ) then  ! /
         d( n ).glin = d( n ).lin + 1
         d( n ).gcol = d( n ).col - 1
      else if ( d( n ).ang .EQ. 7 ) then  ! -
         d( n ).glin = d( n ).lin
         d( n ).gcol = d( n ).col - 1
      else if ( d( n ).ang .EQ. 8 ) then  ! \
         d( n ).glin = d( n ).lin - 1
         d( n ).gcol = d( n ).col - 1
      else
         stop 'PROG ERROR'
      end if
      !
      !
      ! Move death ray...
      !
      if ( d( n ).DR_distance .GE. max_DR_distance ) then
         ! Death ray reached max distance
         !
         call daleks_cancel_DR( n )
         !
      else if ( d( n ).DR_distance .GE. 0 ) then
         !
         !
         d( n ).DR_distance = d( n ).DR_distance + 1
         do I = 5, 2, -1
            d( n ).DR_lin( I ) = d( n ).DR_lin( I - 1 )
            d( n ).DR_col( I ) = d( n ).DR_col( I - 1 )
         end do
         !
         if ( d( n ).DR_distance .EQ. 1 ) then
            lin = d( n ).glin
            col = d( n ).gcol
            ang = d( n ).ang
            d( n ).DR_ang = ang
         else
            lin = d( n ).DR_lin( 1 )
            col = d( n ).DR_col( 1 )
            ang = d( n ).DR_ang
         end if
         !
         OK_count = 0
         error_count = 0
         do while ( OK_count .EQ. 0 .and. error_count .LE. 5 )
            !
            call daleks_next_place( lin, col, ang, temp_lin, temp_col )
            !
            if ( error_count .EQ. 0 ) then
               lin = temp_lin
               col = temp_col
            end if
            !
            if ( temp_lin .LT. 1 .or. temp_col .LT. 1 ) goto 30
            ! ...ignore checking since the DR has escaped the world.
            !
            if ( wld( temp_lin )( temp_col:temp_col ) .GE. '_' ) then
               !
               ! The death ray has hit a surface so reflect it back using the
               ! angle if incidence!
               !
               error_count = error_count + 1
               !
               if ( ang .EQ. 1 ) then
                  !
                  ang = 5
                  goto 20
                  !
               else if ( ang .EQ. 2 ) then
                  !
                  if ( wld( temp_lin )( temp_col-1:temp_col-1 ) .LT. '_' .and.
     .                 wld( temp_lin+1 )( temp_col:temp_col ) .LT. '_' ) then
                     ang = 6
                     goto 20
                  elseif ( wld( temp_lin )( temp_col-1:temp_col-1 ) .LT. '_' ) then
                     ang = 8
                     goto 20
                  elseif ( wld( temp_lin+1 )( temp_col:temp_col ) .LT. '_' ) then
                     ang = 4
                     goto 20
                  else
                     ang = 6
                     goto 20
                  end if
                  !
               else if ( ang .EQ. 3 ) then
                  !
                  ang = 7 
                  goto 20
                  !
               else if ( ang .EQ. 4 ) then
                  !
                  if ( wld( temp_lin )( temp_col-1:temp_col-1 ) .LT. '_' .and.
     .                 wld( temp_lin-1 )( temp_col:temp_col ) .LT. '_' ) then
                     ang = 8
                     goto 20
                  elseif ( wld( temp_lin )( temp_col-1:temp_col-1 ) .LT. '_' ) then
                     ang = 6
                     goto 20
                  elseif ( wld( temp_lin-1 )( temp_col:temp_col ) .LT. '_' ) then
                     ang = 2
                     goto 20
                  else
                     ang = 8
                     goto 20
                  end if
                  !
               else if ( ang .EQ. 5 ) then
                  !
                  ang = 1 
                  goto 20
                  !
               else if ( ang .EQ. 6 ) then
                  !
                  if ( wld( temp_lin )( temp_col+1:temp_col+1 ) .LT. '_' .and.
     .                 wld( temp_lin-1 )( temp_col:temp_col ) .LT. '_' ) then
                     ang = 2
                     goto 20
                  elseif ( wld( temp_lin )( temp_col+1:temp_col+1 ) .LT. '_' ) then
                     ang = 4
                     goto 20
                  elseif ( wld( temp_lin-1 )( temp_col:temp_col ) .LT. '_' ) then
                     ang = 8
                     goto 20
                  else
                     ang = 2
                     goto 20
                  end if
                  !
               else if ( ang .EQ. 7 ) then
                  !
                  ang = 3 
                  goto 20
                  !
               else if ( ang .EQ. 8 ) then
                  !
                  if ( wld( temp_lin )( temp_col+1:temp_col+1 ) .LT. '_' .and.
     .                 wld( temp_lin+1 )( temp_col:temp_col ) .LT. '_' ) then
                     ang = 4
                     goto 20
                  elseif ( wld( temp_lin )( temp_col+1:temp_col+1 ) .LT. '_' ) then
                     ang = 2
                     goto 20
                  elseif ( wld( temp_lin+1 )( temp_col:temp_col ) .LT. '_' ) then
                     ang = 6
                     goto 20
                  else
                     ang = 2
                     goto 20
                  end if
                  !
               end if
               !
            else
               !
               OK_count = OK_count + 1
               !
            end if
            !
            !
20       end do
         !
30       if ( error_count .GE. 5 ) then
            call Daleks_cancel_DR( n )
         else
            d( n ).DR_lin( 1 ) = temp_lin
            d( n ).DR_col( 1 ) = temp_col
            d( n ).DR_ang = ang
         end if
         !
         !
      end if 
      !
      if ( d( n ).lin .GE. 1 .and.
     .     d( n ).col .GE. 1      ) then
         !
         if ( wld( d( n ).lin )( d( n ).col:d( n ).col ) .EQ. '#' )
     .      d( n ).health = max_health
         if ( wld( d( n ).lin )( d( n ).col:d( n ).col ) .EQ. '@' )
     .      d( n ).health = 1
         if ( wld( d( n ).lin )( d( n ).col:d( n ).col ) .GE. '0' .and.
     .        wld( d( n ).lin )( d( n ).col:d( n ).col ) .LE. '9' )
     .      call daleks_telepad( wld( d( n ).lin )( d( n ).col:d( n ).col ) )
      end if                    
      !
      end





      options/extend_source
      subroutine daleks_telepad( current_pad )
      !
      !
      !
      implicit none
      include 'daleks_inc.for'
      character current_pad*1, next_pad*1
      integer*4 lin, col
      !
      if ( current_pad .EQ. '9' ) then
         next_pad = '0'
      else
         next_pad = char( ichar( current_pad ) + 1 )
      end if
      !
      !
      do lin = 1, wld_height
         !
         col = index( wld( lin )(1:wld_width), next_pad )
         !
         if ( col .GT. 0 ) then
            if ( wld( od( n ).lin )( od( n ).col:od( n ).col ) .GE. '0' .and.
     .           wld( od( n ).lin )( od( n ).col:od( n ).col ) .LE. '9' )
     .         RETURN  ! old position was also a telepad so the daleks
            ! has not just moved onto it so don't teleport it
            ! 
            call daleks_beep
            d( n ).glin = lin + ( d( n ).glin - d( n ).lin )
            d( n ).lin = lin
            d( n ).gcol = col + ( d( n ).gcol - d( n ).col )
            d( n ).col = col
            call daleks_beep
            return
         end if
         !
      end do
      !
      !
      end


      options/extend_source
      subroutine daleks_draw
      !
      !
      implicit none
      include 'daleks_inc.for'
      integer*4 I, J, k, old_wld_offs_lin,
     .    old_wld_offs_col, closest_dalek_dist, dist, temp
      !
      old_wld_offs_lin = wld_offs_lin
      old_wld_offs_col = wld_offs_col
      !
      ! See if a new window needs displaying...
      !
      if ( d( n ).col - wld_offs_col .GT. win_width - 3 .or.
     .     d( n ).col - wld_offs_col .LT. 3 .or.
     .     d( n ).lin - wld_offs_lin .GT. win_height - 3 .or.
     .     d( n ).lin - wld_offs_lin .LT. 3  ) then
         !
         !
         wld_offs_lin = d( n ).lin - ( win_height / 2 )
         wld_offs_col = d( n ).col - ( win_width / 2 )
         if ( wld_offs_lin .LT. 0 ) wld_offs_lin = 0
         if ( wld_offs_col .LT. 0 ) wld_offs_col = 0
         if ( wld_offs_lin .GT. wld_height - win_height )
     .      wld_offs_lin =  wld_height - win_height 
         if ( wld_offs_col .GT. wld_width - win_width )
     .      wld_offs_col =  wld_width - win_width
         !
         if ( old_wld_offs_lin .NE. wld_offs_lin .or.
     .        old_wld_offs_col .NE. wld_offs_col   ) then
            ! display the new backdrop and redraw the daleks
            !
            call daleks_backdrop
            !
            do I = 1, max_daleks
               !
               call daleks_draw_dalek( I, -1, 0, -1, -1, -1 )
               !
            end do
            goto 99 ! All daleks have been redisplayed so no need to
            !         do the normal display code so skip it
            !
         end if
         !
      end if 
      !
      !
      ! Death ray stuff...
      !
      !
      do I = 1, max_daleks
         !
         if ( d( I ).DR_distance .GT. 0 )
     .      call daleks_print( d( I ).DR_lin( 1 ), d( I ).DR_col( 1 ), '*' )
         !
         if ( od( I ).DR_distance .GE. 5 )
     .      call daleks_blank( od( I ).DR_lin( 5 ), od( I ).DR_col( 5 ) )
         !
         if ( d( I ).DR_distance .EQ. -1 .and.
     .        od( I ).DR_distance .GT. 0 ) then
            !
            do k = 1, 5
               ! 
               if ( od( I ).DR_lin( k ) .GT. 0 )
     .            call daleks_blank( od( I ).DR_lin( k ), od( I ).DR_col( k ) )
               !
               do j = 1, max_daleks ! refresh any daleks in the deathray path
                  ! when it expires.
                  !
                  ! This bit of code is a bit inefficient yet should not happen
                  ! very often anyway since it only happens when a dalek
                  ! is revealed when a death-ray expires.
                  !
                  if ( d( j ).status .NE. 0 ) then
                     if ( ( od( I ).DR_lin( k ) .EQ. d( j ).lin .or.
     .                      od( I ).DR_lin( k ) .EQ. d( j ).glin    ) .and.
     .                    ( od( I ).DR_col( k ) .EQ. d( j ).col .or.
     .                      od( I ).DR_col( k ) .EQ. d( j ).gcol    )       ) then
                        call daleks_draw_dalek( I, -1, 0, -1, -1, -1 )
                     end if
                  end if
               end do
               !
            end do 
            !
            !
         end if
         !
         if ( d( I ).DR_distance .GT. 4 ) then
            !
            do j = 1, max_daleks ! refresh any daleks on the tail end
               !    of the death ray
               if ( d( j ).status .NE. 0 ) then
                  if ( ( od( I ).DR_lin( 5 ) .EQ. d( j ).lin .or.
     .                   od( I ).DR_lin( 5 ) .EQ. d( j ).glin    ) .and.
     .                 ( od( I ).DR_col( 5 ) .EQ. d( j ).col .or.
     .                   od( I ).DR_col( 5 ) .EQ. d( j ).gcol    )       ) then
                     call daleks_draw_dalek( I, -1, 0, -1, -1, -1 )
                  end if
               end if
            end do
            !
         end if
         !
         if ( d( I ).DR_distance .EQ. 1 ) call daleks_beep
         !
      end do
      !
      !
      !
      ! Draw daleks and also find the closest dalek...
      !
      closest_dalek = 'none'
      closest_dalek_dist = 32767
      temp = 0
      !
      do I = 1, max_daleks
         !
         call daleks_draw_dalek( I, -1, -1, -1, -1, 0 )
         !
         if ( I .NE. n .and. d( I ).status .NE. 0 ) then
            dist = abs( d( n ).lin - d( I ).lin )
            if ( abs( d( n ).col - d( I ).col ) .GT. dist )
     .         dist = abs( d( n ).lin - d( I ).lin )
            !
            if ( dist .LT. closest_dalek_dist ) then
               closest_dalek_dist = dist
               closest_dalek = char( 48 + I )
               temp = I
            end if
         end if
         !
98    end do
      !
      if ( temp .NE. 0 ) then
         if ( d( n ).lin - d( temp ).lin .LT. 0 ) then
            closest_dalek(3:3) = 'S'
         else if ( d( n ).lin - d( temp ).lin .GT. 0 ) then
            closest_dalek(3:3) = 'N'
         end if
         if ( d( n ).col - d( temp ).col .LT. 0 ) then
            closest_dalek(4:4) = 'E'
         else if ( d( n ).col - d( temp ).col .GT. 0 ) then
            closest_dalek(4:4) = 'W'
         end if
      end if
      !
      call daleks_status
      !
99    end




      options/extend_source
      subroutine daleks_draw_dalek( I,
     .           print_flag, erase_flag, body_flag, gun_flag, force_flag )
      !
      ! Draw a dalek at the current angle etc...
      !
      implicit none
      include 'daleks_inc.for'
      integer*4  I, print_flag, erase_flag, body_flag, gun_flag,
     .           force_flag
      !
      if ( d( I ).status .EQ. 0 .and. od( I ).status .EQ. 0 ) return
      ! ...no output required so just exit
      !
      if ( body_flag .NE. 0 .and.
     .     ( force_flag .NE. 0 .or.
     .       od( I ).lin .NE. d( I ).lin .or.
     .       od( I ).col .NE. d( I ).col .or.
     .       od( I ).status .NE. d( I ).status ) ) then
         ! blank-out old body and display in new pos
         !
         if ( erase_flag .NE. 0 .and.
     .        ( force_flag .NE. 0 .or. od( I ).status .NE. 0 ) )
     .      call daleks_blank( od( I ).lin, od( I ).col )
         !
         !
         if ( print_flag .NE. 0 ) then
            if ( d( I ).status .EQ. 1 ) then
               call daleks_print( d( I ).lin, d( I ).col, 'O' )
            else if ( d( I ).status .EQ. 9 ) then
               call daleks_beep
               call daleks_print( d( I ).lin, d( I ).col, 'o' )
               call daleks_beep
            else if ( d( I ).status .EQ. 8 ) then
               call daleks_print( d( I ).lin, d( I ).col, 'o' )
               call daleks_beep
            else if ( d( I ).status .EQ. 7 ) then
               call daleks_print( d( I ).lin, d( I ).col, 'O' )
               call daleks_beep
            else if ( d( I ).status .EQ. 6 ) then
               call daleks_print( d( I ).lin, d( I ).col, 'o' )
               call daleks_beep
            else if ( d( I ).status .EQ. 5 ) then
               call daleks_print( d( I ).lin, d( I ).col, '.' )
               call daleks_beep
            else
               call daleks_blank( d( I ).lin, d( I ).col )
            end if
         end if
         !
      end if
      !
      if ( gun_flag .NE. 0 .and.
     .     ( od( I ).glin .NE. d( I ).glin     .or.
     .       od( I ).gcol .NE. d( I ).gcol     .or.
     .       od( I ).ang  .NE. d( I ).ang      .or.
     .       od( I ).status .NE. d( I ).status .or.
     .       force_flag .NE . 0                     ) ) then
         ! blank-out old gun and display in new position or orientation...
         !
         if ( erase_flag .NE. 0 .and.
     .        ( force_flag .NE. 0 .or. od( I ).status .NE. 0 ) )then
            if ( od( I ).glin .NE. d( I ).lin .or.
     .           od( I ).gcol .NE. d( I ).col     ) then
               call daleks_blank( od( I ).glin, od( I ).gcol )
            end if
         end if
         !
         if ( d( I ).status .EQ. 1 .or.
     .        d( I ).status .EQ. 5 .or.
     .        d( I ).status .EQ. 6 .or.
     .        d( I ).status .EQ. 7 .or.
     .        d( I ).status .EQ. 8 .or.
     .        d( I ).status .EQ. 9  ) then
            if ( d( I ).ang .EQ. 1 ) then
               call daleks_print( d( I ).glin, d( I ).gcol, '|' )
            else if ( d( I ).ang .EQ. 2 ) then
               call daleks_print( d( I ).glin, d( I ).gcol, '/' )
            else if ( d( I ).ang .EQ. 3 ) then
               call daleks_print( d( I ).glin, d( I ).gcol, '-' )
            else if ( d( I ).ang .EQ. 4 ) then
               call daleks_print( d( I ).glin, d( I ).gcol, '\' )
            else if ( d( I ).ang .EQ. 5 ) then
               call daleks_print( d( I ).glin, d( I ).gcol, '|' )
            else if ( d( I ).ang .EQ. 6 ) then
               call daleks_print( d( I ).glin, d( I ).gcol, '/' )
            else if ( d( I ).ang .EQ. 7 ) then
               call daleks_print( d( I ).glin, d( I ).gcol, '-' )
            else if ( d( I ).ang .EQ. 8 ) then
               call daleks_print( d( I ).glin, d( I ).gcol, '\' )
            else 
               print *, 'INVALID ANGLE in DALEKS_DRAW_DALEK'
            end if
         else if ( d( I ).status .EQ. 5 ) then
            call daleks_print( d( I ).glin, d( I ).gcol, '*' )
         else
            call daleks_blank( d( I ).glin, d( I ).gcol )
         end if
         !
      end if
      !
      end












      options/extend_source
      subroutine daleks_status
      !
      ! update the status line
      !
      implicit none
      include 'daleks_inc.for'
      !
      ! Check if the character is on the virtual display...
      !
      if ( d( n ).speed .NE. od( n ).speed ) then
         write ( unit=99 ) char( 27 ) // 'Y' //
     .                     char( 24 + 31 ) //
     .                     char(  7 + 31 ) //
     .                     char( abs( d( n ).speed ) + 48 )
         next_lin = -1
         next_col = -1
      end if
      !
      !
      if ( d( n ).health .NE. od( n ).health ) then
         write ( unit=99 ) char( 27 ) // 'Y' //
     .                     char( 24 + 31 ) //
     .                     char( 18 + 31 ) //
     .                     char( abs( d( n ).health ) + 48 )
         next_lin = -1
         next_col = -1
      end if
      !
      if ( d( n ).DR_distance .EQ. -1 .and. od( n ).DR_distance .NE. -1 .or.
     .     d( n ).DR_distance .NE. -1 .and. od( n ).DR_distance .EQ. -1 ) then
         !
         write ( unit=99 ) char( 27 ) // 'Y' //
     .                     char( 24 + 31 ) //
     .                     char( 32 + 31 )
         !
         if ( d( n ).status .EQ. 0 ) then
            write ( unit=99 ) 'malfunction'
         else if ( d( n ).DR_distance .EQ. -1 ) then
            write ( unit=99 ) 'CHARGED!'
         else
            write ( unit=99 ) 'charging'
         end if
         !
         next_lin = -1
         next_col = -1
         !
      end if
      !
      if ( old_closest_dalek .NE. closest_dalek ) then
         !
         write ( unit=99 ) char( 27 ) // 'Y' //
     .                     char( 24 + 31 ) //
     .                     char( 48 + 31 ) //
     .                     closest_dalek
         !
         next_lin = -1
         next_col = -1
         !
      end if
      !
      old_closest_dalek = closest_dalek
      !
      !
      end


      options/extend_source
      subroutine daleks_beep
      !
      implicit none
      write ( unit=99 ) char( 7 )
      !
      end



      options/extend_source
      subroutine daleks_print( lin, col, str )
      !
      implicit none
      include 'daleks_inc.for'
      integer*4 lin, col, comp_lin, comp_col
      character*(*) str
      !
      comp_lin = lin - wld_offs_lin + win_offs_lin
      comp_col = col - wld_offs_col + win_offs_col
      !
      ! Check if the character is on the virtual display...
      !
      if ( comp_lin .LT. win_offs_lin + 1 .or.
     .     comp_col .LT. win_offs_col + 1 .or.
     .     comp_lin .GT. win_height + win_offs_lin .or.
     .     comp_col .GT. win_width + win_offs_col      ) RETURN
      !
      !
      if ( comp_col .eq. next_col .and.
     .     comp_lin .eq. next_lin       ) then
         write ( unit=99 ) str
      else if ( comp_col .eq. next_col .and.
     .          comp_lin .eq. next_lin + 1      ) then
         write ( unit=99 ) char( 10 ) // str
      else
         write ( unit=99 ) char( 27 ) // 'Y' //
     .         char( comp_lin + 31 ) //
     .         char( comp_col + 31 ) // str
      end if
      !
      next_lin = comp_lin
      next_col = comp_col + len( str )
      !
      end




      options/extend_source
      subroutine daleks_blank( lin, col )
      !
      ! Replace an old character with background
      !
      implicit none
      include 'daleks_inc.for'
      integer*4 lin, col, comp_lin, comp_col
      !
      !
      comp_lin = lin - wld_offs_lin + win_offs_lin
      comp_col = col - wld_offs_col + win_offs_col
      !
      ! Check if the space is on the virtual display...
      !
      if ( comp_lin .LT. win_offs_lin + 1 .or.
     .     comp_col .LT. win_offs_col + 1 .or.
     .     comp_lin .GT. win_height + win_offs_lin .or.
     .     comp_col .GT. win_width + win_offs_col      ) RETURN
      !
      if ( comp_col .eq. next_col .and.
     .     comp_lin .eq. next_lin       ) then
         write ( unit=99 ) wld( lin )( col:col )
      else if ( comp_col .eq. next_col .and.
     .          comp_lin .eq. next_lin + 1      ) then
         write ( unit=99 ) char( 10 ) // wld( lin )( col:col )
      else
         write ( unit=99 ) char( 27 ) // 'Y' //
     .         char( comp_lin + 31) //
     .         char( comp_col + 31) //
     .         wld( lin )( col:col )
      end if
      !
      next_lin = comp_lin
      next_col = comp_col + 1
      !
      end




      options/extend_source
      subroutine DALEKS_backdrop
      !
      implicit none
      include 'daleks_inc.for'
      integer*4 I, J
      character line*132, width_esc*3
      !
      !
      ! Write all graphic characters...
      !
      if ( width_mode .NE. 0 ) then
         width_esc =  char( 27 ) // '#6'
      else
         width_esc = char( 0 ) // char( 0 ) // char( 0 )
      end if
      !
      write( unit=99 ) 
     .   char( 27 ) // '<' //
     .   char( 27 ) // '(0' // 
     .   char( 27 ) // '[H' //
     .   char( 27 ) // '[m' //
     .   width_esc //
     .   'lqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqk' //
     .   char( 13 ) // char( 10 )
      !
      do I = 1, win_height
         !
         line = wld( I + wld_offs_lin )(1+wld_offs_col:win_width+wld_offs_col)
         !
         do J = 1, win_width
            if ( line(J:J) .EQ. '_' ) line(J:J) = ' ' !invisible force fields
         end do
         !
         write ( unit=99 )
     .      width_esc //
     .      'x' //
     .      line(1:win_width) //
     .      'x' // char( 13 ) // char( 10 )
         !
      end do
      !
      write( unit=99 )
     .   width_esc //   
     .   'mqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqj' // 
     .   char( 27 ) // '[?25l' //  !make cursor invisible
     .   char( 27 ) // '[?2l' // char( 10 ) // char( 13 )
      !
      ! Write the status line...
      !
      write ( unit=99 ) 'Speed ' //
     .                  char( abs( d( n ).speed ) + 48 ) //
     .                  '   Health ' //
     .                  char( abs( d( n ).health ) + 48 ) //
     .                  '   Death-ray '
      !
      if ( d( n ).DR_distance .EQ. -1 ) then
         write ( unit=99 ) 'CHARGED!'
      else
         write ( unit=99 ) 'charging'
      end if
      !
      write ( unit=99 ) '   Scan '
      !
      !   ... now back to good ol' VT52 mode and USA char set
      !
     .!   char( 27 ) // '(B'//
      !
      next_lin = -1
      next_col = -1
      !
      !
      end



      options/extend_source
      subroutine daleks_screen_ini
      !
      !
      implicit none
      !
      !
      open ( unit=99, file='TT:', organization='sequential',
     .       carriagecontrol='NONE',status='OLD', form='UNFORMATTED' )  !screen channel
      !
      write ( unit=99 ) char( 27 ) // '[?2l'  ! VT52 mode for graphics speed
      !
      end     



      options/extend_source
      subroutine daleks_screen_term
      !
      !
      implicit none
      !
      !
      write ( unit=99 ) char( 27 ) // '<' //      ! back to ANSII mode
     .                  char( 27 ) // '[?25h'     ! make cursor visible again
      !
      close ( unit=99 )
      !
      end     

