      options /extend_source
      program daleks_server
      !
      !
      implicit none
      !
      include '($lnmdef)'
      !
      include 'daleks_inc.for'
      include 'daleks_server_inc.for'
      !
      character*8 d_logical( max_daleks )
      character translation*256, dalek_name*30
      integer*4 status, sys$trnlnm, reset_flag, lock_file_already_existed,
     .          daleks_read, daleks_write, dalek_name_len,
     .          post_trim, sys$crembx, I, exit_required,
     .          d_collision( max_daleks ), daleks_collision, lib$find_file,
     .          read_tries, daleks_connected, key_code, context
      integer*2 return_length
      parameter true = -1, false = 0
      !
      structure/item_list/
         integer*2 buffer_length
         integer*2 item_code
         integer*4 buffer_address
         integer*4 return_length_address
         integer*4 end_item/0/
      end structure
      !
      record/item_list/ item1
      !
      status = lib$find_file( 'DALEKS_DIR:DALEKS_SERVER_LOCK.DAT',
     .                        translation, context )
      call lib$find_file_end( context )
      !
      if ( IAND( status, 1 ) .EQ. 1 ) then
         lock_file_already_existed = true
      else
         lock_file_already_existed = false
      end if
      !
      ! OPEN the test file to see if a server is already running etc...
      !
      open ( unit=5, file='DALEKS_DIR:DALEKS_SERVER_LOCK.DAT',
     .       organization='sequential', carriagecontrol='none',
     .       IOstat=status, status='unknown' )
      !
      if ( status .EQ. 30 ) then
         print *, 'The daleks server is probably already running.'
         print *, '( it is also possible that DALEKS_DIR:DALEKS_SERVER_LOCK.DAT'
         print *, '  is inaccessable to you due to lack of privileges ... in'
         print *, '  this case see you''re system manager )'
         call lib$wait( 2.0 )
         goto 100  ! terminate immediately
      else if ( status .NE. 0 ) then
         print *, 'Error trying to open the DALEKS_DIR:DALEKS_SERVER_LOCK.DAT'
         print *, 'FORTRAN error #', status
         print *, '(check that the DALEKS_DIR: logical is defined and that you'
         print *, ' have access to it)'
      end if
      !
      write ( unit=5, fmt='(a)' ) 'This is a locking file for the Daleks sever.'
      write ( unit=5, fmt='(a)' ) 'When this file is locked (unsharable) then'
      write ( unit=5, fmt='(a)' ) 'the Daleks server can be assumed to be running'
      !
      !
      !
      !
      !
      !
      ! initialize dalek data areas
      do n = 1, max_daleks
         !
         d( n ).status = 0
         !
      end do
      !
      call daleks_read_world( 1 )
      !
      print *, 'The daleks server is up.'
      print *, 'To exit this server and all sessions press control Z'
      PRINT *, 'World width :', wld_width
      PRINT *, 'World height:', wld_height
      !
      open ( unit=1, file='DALEKS_DIR:daleks.dat',
     .       carriagecontrol='list', status='unknown' ) 
      !
      do n = 1, max_daleks
         !
         d_logical( n ) = 'DALEK'
         call int4_to_str( n, d_logical( n )(6:8) )
         do I = 6, 8
            if ( d_logical( n )(I:I) .Eq. ' ' ) d_logical( n )(I:I) = '0'
         end do
         d_mbx_ch( n ) = 0
         !
         status = sys$crembx( , d_mbx_ch( n ),
     .                        %val( 512 ), %val( 512 ),,,
     .                        d_logical( n ) )
         !
         ! Evaluate the logical name to a mailbox device (eg MBA234:)...
         !
         item1.buffer_length = len( translation )
         item1.item_code = lnm$_string
         item1.buffer_address = %loc( translation )
         item1.return_length_address = %loc( return_length )
         !
         status = sys$trnlnm( lnm$M_case_blind, 'LNM$JOB',
     .                    d_logical( n ),,ITEM1 )
         !
         if ( IAND( status, 1 ) .NE. 1 ) then
            print *, 'Could not translate logical name of mailbox ' // d_logical( n )
            if ( status .EQ. 444 ) print *, '**** NOTE that your process must have TMPMBX priv. set'
            print *, 'VMS error number:', status
            call lib$signal( %val( status ) )
         end if
         !
         dalek_name =                  '  A lowly Drone'
         if ( n .Eq.  1 ) dalek_name = '           Fred'
         if ( n .Eq.  2 ) dalek_name = '      Mesh-Face'
         if ( n .Eq.  3 ) dalek_name = '      Metaleena'
         if ( n .Eq.  4 ) dalek_name = '    Frobbleneck'
         if ( n .Eq.  5 ) dalek_name = '    Flash-Harry'
         if ( n .Eq.  6 ) dalek_name = '   Plunger-Face'
         if ( n .Eq.  7 ) dalek_name = 'Terminator-Todd'
         if ( n .Eq.  8 ) dalek_name = '        Tinhead'
         if ( n .Eq.  9 ) dalek_name = '      Fortisque'
         if ( n .Eq. 10 ) dalek_name = '  Nobbly-Turret'
         dalek_name_len = post_trim( dalek_name )         
         !
         write ( unit=1, fmt='(A,I2,A)' ) dalek_name(1:dalek_name_len) //
     .                    ', dalek number #',
     .                    n,
     .                    ' =' // translation(1:return_length) //
     .                    ' |                    '
         !
      end do
      !
      close ( unit=1 )
      !
      do n = 1, max_daleks
         !
         od( n ).status = 0
         d( n ).status = 0
         !
      end do
      !
      key_code = 0
      reset_flag = -1
      exit_required = 0
      do while ( exit_required .EQ. 0 .or. daleks_connected .GT. 0 )
         !
         daleks_connected = 0
         !
         call daleks_inkey( key_code )
         If ( key_code .EQ. 26 ) then
            print *, 'Exit sequence initiated.'
            exit_required = -1
         end if
         !
         do n = 1, max_daleks
            !
            read_tries = 0
            !
30          status = daleks_read( n )
            read_tries = read_tries + 1
            !
            if ( status .EQ. 1 ) then
               daleks_connected = daleks_connected + 1
               if ( exit_required ) d( n ).status = 0
            else if ( status .EQ. 0 ) then
               if ( od( n ).status .NE. 0 .and. read_tries .LE. 30 ) then
                  call lib$wait( 0.1 )
                  goto 30
               end if
               ! if ( od( n ).status .NE. 0 ) print *, 'DALEK', n, ' Exit on read'
               d( n ).status = 0
               od( n ).status = 0
            else
               print *, 'Invalid status from dalek read'
            end if
            !
         end do
         !
         do n = 1, max_daleks
            !
            if ( d( n ).status .GT. 0 ) then
               !
               d_collision( n ) = IOR( 
     .              daleks_collision( d( n ).lin, d( n ).col, n ),
     .              daleks_collision( d( n ).glin, d( n ).gcol, n ) )
               !
            else
               d_collision( n ) = 0
            end if
            !
         end do            
         !
         do n = 1, max_daleks
            !
            ! if ( d_collision( n ) .Ne. 0 ) print *,d_collision( n )
            if ( IAND( d_collision( n ), 1 ) .NE. 0 .and.
     .           od( n ).status .GT. 0 .and.
     .           d( n ).status .GT. 0 ) then
               ! print *, 'collision adjusted'
               d( n ).lin = od( n ).lin
               d( n ).col = od( n ).col
               d( n ).glin = od( n ).glin
               d( n ).gcol = od( n ).gcol
               d( n ).ang = od( n ).ang
               d( n ).speed = 0
               d( n ).move_count = 0
            end if
            if ( IAND( d_collision( n ), 8 ) .NE. 0 ) then
               !
               if ( d( n ).health .GT. 0 )
     .            d( n ).health = d( n ).health - 1
               ! print *, 'Dalek hit - Whaaa!'
               if ( d( n ).health .EQ. 0 )
     .            d( n ).status = 9
            end if
            !
         end do
         !
         do n = 1, max_daleks
            !
            if ( d( n ).status .GT. 0 .or. od( n ).status .GT. 0 ) then
               !
               status = daleks_write( n )
               if ( status .NE. 1 ) then
                  ! if ( od( n ).status .NE. 0 ) print *, 'DALEK', n, ' Exit on write'
                  d( n ).status = 0
               end if
               !
            end if
            !
         end do
         !
         do I = 1, max_daleks
            od( I ) = d( I )
         end do
         !
         if ( daleks_connected .LE. 3 ) call lib$wait( 0.05 )
         !   ... reduce the slowing effect of additional Dalek connections
         !          by falsely slowing the initial daleks
         !
         if ( daleks_connected .EQ. 0 ) then
            if ( reset_flag .EQ. 0 ) call daleks_reser( reset_flag )
            call lib$wait( 1.0 )
         else
            reset_flag = 0
         end if
         !
      end do
      !
99    call sys$dassgn( %val( kb_ch ) )
      !
      do n = 1, max_daleks
         !
         call sys$dassgn( %val( d_mbx_ch( n ) ) )
         !
      end do
      !
      close( unit=5 ) ! close the locking file
      print *, 'Server ended.'
      if ( lock_file_already_existed .EQ. false )
     .    call lib$do_command( 
     .        'set file daleks_dir:daleks_server_lock.dat/prot=w:rwd' )
      !
100   end



      options/extend_source
      subroutine daleks_reser( reset_flag )
      !
      implicit none
      integer*4 status, reset_flag, pos, rec_len
      character text*132
      !
      open ( unit=1, file='DALEKS_DIR:daleks.dat',
     .       carriagecontrol='list', status='unknown',
     .       IOstat=status ) 
      !
      if ( status .NE. 0 ) RETURN  ! the file might be locked so abort
      !
      status = 0
      do while ( status .EQ. 0 )
         !
         read ( unit=1, fmt='(q,a)', IOstat=status ), rec_len, text
         !
         if ( status .EQ. 0 ) then
            pos = index( text, '/' )
            if ( pos .EQ. 0 ) pos = index( text, '\' )
            !
            if ( pos .GT. 0 ) then
               text(pos:pos) = '#'   ! cancel dalek from daleks.dat
               rewrite ( unit=1, fmt='(a)' ) text(1:rec_len)
            end if
            !
         end if
         !
      end do
      !
      close ( unit=1 )
      !
      reset_flag = -1
      !
      end




      options/extend_source
      integer function daleks_collision*4( lin, col, num )
      !
      ! Returns 1 for collisions that need position correction
      !         8 if death-rayed
      !
      !
      implicit none
      include 'daleks_inc.for'
      integer*4  lin, col, I, num, st, j
      !
      st = 0
      !
      if ( lin .LT. 1 .or. col .LT. 1 ) then
         st = 1
         goto 99
      end if
      !
      if ( lin .GT. wld_height ) then
         st = 1
         goto 99
      end if
      !
      if ( col .GT. wld_width ) then
         st = 1
         goto 99
      end if
      !
      if ( wld( lin )( col:col ) .GE. '_' ) then
         st = 1
         goto 99
      end if
      !
      do I = 1, max_daleks
          !
          if ( I .NE. num .and. d( I ).status .NE. 0 ) then
             !
             if ( ( lin .EQ. d( I ).lin .and. col .EQ. d( I ).col ) .or.
     .            ( lin .EQ. d( I ).glin .and. col .EQ. d( I ).gcol ) ) then
                st = 1
                goto 99
             end if
             !
          end if
          !
          if ( d( I ).status .EQ. 1 ) then
             !
             do j = 1, 5
                !
                if ( lin .EQ. d( I ).DR_lin( j ) .and.
     .               col .EQ. d( I ).DR_col( j )       ) then
                   if ( d( I ).DR_distance .GT. 5 .or.
     .                  I .NE. num ) then
                      st = 8
                      goto 99
                   end if
                end if
                !
             end do
             !
          end if
          !
      end do 
      !
      ! if ( st .NE. 0 )
      !.    print *, '*Collis@', st, lin, col
99    daleks_collision = st
      !
      end




      options/extend_source
      integer function daleks_read*4( num )
      !
      implicit none
      include 'daleks_inc.for'
      include 'daleks_server_inc.for'
      character buffer*51
      include '($SSDEF)'
      include '($SYSSRVNAM)'
      include '($IODEF)'
      !
      integer*4 status, status2, function_code, num
      !
      !
      structure /TT_read_IOSB/
         integer*2   status
         integer*2   bytes_read
         integer*4   %fill
      end structure
      record/TT_read_IOSB/ IOSB
      !
      structure /term_mask_struct/
         integer*2 size
         integer*2 filler
         integer*4 address
      end structure
      record/term_mask_struct/term_mask
      !
      term_mask.size = 0
      term_mask.filler = 0   ! use short form of term mask.
      term_mask.address = 0  
      !
      !
      daleks_read = 1 ! default to success
      !
      IOSB.status = 0
      IOSB.bytes_read = 0
      !
      function_code = IO$_READVBLK + IO$M_NOECHO  + IO$M_NOFILTR !+
      !.                IO$M_TIMED
      !                
      status = sys$qiow( %val( 1 ),
     .               %val( d_mbx_ch( num ) ),
     .               %val( function_code ),
     .               IOSB, , ,
     .               %REF( buffer ),
     .               %val( len( buffer ) ),
     .               %val( 0 ), %val( %loc( term_mask ) ),
     .               %val( 0 ), %val( 0 ) )
      !
      if ( status .NE. ss$_normal ) then
         !
         print *, '** Error on read (DALEKS_READ) **     (', status, '  )'
         call lib$stop( %val( status ) )
         !
      end if
      !
      if ( IOSB.status .EQ. 2160 ) then  ! end of file
         daleks_read = 0
         RETURN
      else if ( IOSB.status .NE. ss$_normal ) then
         !
         print *, 'Error reading dalek(s) IOSB.status=',IOSB.status 
         print *, 'IOSB.bytes_read=',IOSB.bytes_read
         daleks_read = 1
         !call lib$stop( %val( IOSB.status ) )
         !
      end if
      !
      read ( unit=buffer, fmt='(I1,4I3,I1,I2,I1,I2,I1,10I3,I1)', IOstat=status2 ) 
     .            d( num ).status,
     .            d( num ).lin,
     .            d( num ).col,
     .            d( num ).glin,
     .            d( num ).gcol,
     .            d( num ).ang,
     .            d( num ).speed,
     .            d( num ).move_count,
     .            d( num ).DR_distance,
     .            d( num ).DR_ang,
     .            d( num ).DR_lin( 1 ),
     .            d( num ).DR_col( 1 ),
     .            d( num ).DR_lin( 2 ),
     .            d( num ).DR_col( 2 ),
     .            d( num ).DR_lin( 3 ),
     .            d( num ).DR_col( 3 ),
     .            d( num ).DR_lin( 4 ),
     .            d( num ).DR_col( 4 ),
     .            d( num ).DR_lin( 5 ),
     .            d( num ).DR_col( 5 ),
     .            d( num ).health
      !
      if ( status2 .NE. 0 ) then 
         !
         print *, 'INPUT CONVERION ERROR. Buffer follows...'
         print *, buffer
         daleks_read = 0
         RETURN
         !
      end if
      !
      if ( IOSB.bytes_read .NE. len( buffer ) ) then
         !
         print *, 'Error reading dalek(s) only ', IOSB.bytes_read,
     .      ' bytes read'
         daleks_read = 0
         RETURN
         !
      end if
      !
      if ( IOSB.status .NE. ss$_normal ) then
         !
         print *, 'Error on read IOSB.status=', IOSB.status
         call lib$stop( %val(  IOSB.status ) )
         daleks_read = 0
         RETURN
         !
      end if
      !
      end



      options /extend_source
      integer function daleks_write*4( num )
      !
      implicit none
      include 'daleks_inc.for'
      include 'daleks_server_inc.for'
      include '($SSDEF)'
      include '($SYSSRVNAM)'
      include '($IODEF)'
      character buffer*510, message*80
      integer*4 status, num, I, buffer_len
      integer*2 temp_word
      !
      structure /TT_WRITE_IOSB/
         integer*2   status
         integer*2   bytes_written
         integer*4   %fill
      end structure
      record/TT_WRITE_IOSB/ IOSB 
      !
      !
      daleks_write = 1 ! default to success
      !
      write( unit=buffer, fmt='(10(I1,4I3,I1,I2,I1,I2,I1,10I3,I1))' ) 
     .         (  d( I ).status,
     .            d( I ).lin,
     .            d( I ).col,
     .            d( I ).glin,
     .            d( I ).gcol,
     .            d( I ).ang,
     .            d( I ).speed,
     .            d( I ).move_count,
     .            d( I ).DR_distance,
     .            d( I ).DR_ang,
     .            d( I ).DR_lin( 1 ),
     .            d( I ).DR_col( 1 ),
     .            d( I ).DR_lin( 2 ),
     .            d( I ).DR_col( 2 ),
     .            d( I ).DR_lin( 3 ),
     .            d( I ).DR_col( 3 ),
     .            d( I ).DR_lin( 4 ),
     .            d( I ).DR_col( 4 ),
     .            d( I ).DR_lin( 5 ),
     .            d( I ).DR_col( 5 ),
     .            d( I ).health,  I=1,10 )
      !
      buffer_len = len( buffer )
      !
      status = sys$qiow( %val( 1 ),
     .               %val( d_mbx_ch( num ) ),
     .               %val( IO$_WRITEVBLK ),
     .               IOSB, , ,
     .               %REF( buffer ),
     .               %val( buffer_len ), ,
     .               %val( 0 ), , )
      !
      if ( status .NE. ss$_normal ) then
         !
         print *, '** Error on write **        (', status, '  )'
         call lib$sys_getmsg( status, temp_word, message )
         print *, message
         daleks_write = 0
         !
      end if
      !
      if ( IOSB.bytes_written .NE. len( buffer ) ) then
         print *, '** error - Could not write all of buffer', IOSB.bytes_written
         daleks_write = 0
      end if
      !
      end
